"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AAA = exports.imm = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const imm = (fn) => () => {
    let output = [];
    const [multiState, setMultistate] = (0, react_1.useState)({});
    fn({
        draw: (jsx) => {
            output.push(jsx);
        },
        drawInput: ({ key, from, to, defaultValue }) => {
            const stateValue = multiState[key] || defaultValue;
            const inputValue = stateValue && to ? to(stateValue) : `${stateValue || ''}`;
            const x = ((0, jsx_runtime_1.jsx)("input", { value: inputValue, onChange: (evt) => {
                    setMultistate(prev => ({
                        ...prev,
                        [key]: from(evt.target.value)
                    }));
                } }));
            output.push(x);
            return stateValue;
        },
        requestJson: ({ method, url, headers: headersParams }) => {
            const stateValue = multiState[url] || undefined;
            const status = multiState["_imm_status_" + url] || undefined;
            if (status === undefined) {
                setMultistate(prev => ({
                    ...prev,
                    ["_imm_status_" + url]: "pending",
                }));
                const headers = new Headers();
                for (const k in headersParams)
                    headers.set(k, headersParams[k]);
                fetch(url, { method, headers }).then(response => response.json()).then(data => {
                    setMultistate(prev => ({
                        ...prev,
                        ["_imm_status_" + url]: "done",
                        [url]: data,
                    }));
                });
            }
            return stateValue;
        },
        state: (key, defaultValue) => {
            return [
                multiState[key] || defaultValue,
                (updater) => {
                    setMultistate(prev => ({
                        ...prev,
                        [key]: typeof updater === 'function' ? updater(prev[key] || defaultValue) : updater
                    }));
                }
            ];
        },
    });
    return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: output.map((x, i) => ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: x }, i))) });
};
exports.imm = imm;
exports.AAA = (0, exports.imm)(({ draw, drawInput, requestJson, state }) => {
    const value = drawInput({
        key: 'x',
        from: x => +x,
        defaultValue: 10
    });
    if (value == 10) {
        const [v] = state('aa', 100);
        draw((0, jsx_runtime_1.jsxs)("div", { children: ["substate ", value + v] }));
    }
    draw((0, jsx_runtime_1.jsx)("div", { children: value + 10 }));
});
//# sourceMappingURL=ebal.js.map