"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualGrid = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const _1 = require(".");
function VirtualGrid(props) {
    const containerRef = (0, react_1.useRef)(undefined);
    const { renderedItems } = (0, _1.useVirtualOverflowGrid)({
        containerRef,
        itemsLengthY: props.items.length,
        itemsLengthX: props.columnsNum,
        itemWidth: props.itemWidth,
        itemHeight: props.itemHeight,
        overscanItemsCount: props.overscanItemsCount,
        calcVisibleRect: props.calcVisibleRect,
        renderItem: (itemIndexX, leftOffsetPx, itemIndexY, topOffsetPx) => {
            const item = props.items[itemIndexY][itemIndexX];
            if (!item)
                return null;
            return ((0, jsx_runtime_1.jsx)("div", { style: { position: 'absolute', top: `${topOffsetPx}px`, left: `${leftOffsetPx}px` }, children: props.renderItem(item, itemIndexX, leftOffsetPx, itemIndexY, topOffsetPx) }, props.itemKey(item, itemIndexX, itemIndexY)));
        }
    }, [props.items, props.itemHeight]);
    return ((0, jsx_runtime_1.jsx)("div", { ref: containerRef, style: { width: `${props.columnsNum * props.itemWidth}px`, height: `${props.items.length * props.itemHeight}px`, position: 'relative' }, children: renderedItems }));
}
exports.VirtualGrid = VirtualGrid;
//# sourceMappingURL=fixed-grid.js.map