"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualListX = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const _1 = require(".");
function VirtualListX(props) {
    const containerRef = (0, react_1.useRef)(undefined);
    const { renderedItems } = (0, _1.useVirtualOverflowX)({
        containerRef,
        itemsLengthX: props.items.length,
        itemWidth: props.itemWidth,
        overscanItemsCount: props.overscanItemsCount,
        calcVisibleRect: props.calcVisibleRect,
        renderItem: (itemIndex, topOffset) => {
            const item = props.items[itemIndex];
            if (!item)
                return null;
            return ((0, jsx_runtime_1.jsx)("div", { style: { position: 'absolute', top: `${topOffset}px` }, children: props.renderItem(item, itemIndex, topOffset) }, props.itemKey(item, itemIndex)));
        }
    }, [props.items, props.itemWidth]);
    return ((0, jsx_runtime_1.jsx)("div", { ref: containerRef, style: { width: `${props.items.length * props.itemWidth}px`, position: 'relative' }, children: renderedItems }));
}
exports.VirtualListX = VirtualListX;
//# sourceMappingURL=fixed-list-x.js.map