"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rvoDebounceAnimationFrame = void 0;
function rvoDebounceAnimationFrame(func) {
    let frameRequest = 0;
    return {
        requestFrame: () => {
            cancelAnimationFrame(frameRequest);
            frameRequest = requestAnimationFrame((frameTime) => func.call(undefined, frameTime));
        },
        cancelFrame: () => cancelAnimationFrame(frameRequest),
    };
}
exports.rvoDebounceAnimationFrame = rvoDebounceAnimationFrame;
//# sourceMappingURL=small-utils.js.map